VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private surfBackround As DirectDrawSurface7
Private surfCar As DirectDrawSurface7
Private surfRotate As DirectDrawSurface7
Private surfMap As DirectDrawSurface7
Private Declare Function timeGetTime Lib "winmm.dll" () As Long

Public Function Terminate()
Set surfRotate = Nothing
Set surfCar = Nothing
Set surfBackround = Nothing
Terminate_DirectX
Unload Me
End
End Function

Private Sub Form_Load()
carx = 200
cary = 200
speed = 0
InitDirectX
InitDirectDraw Me, 640, 480, 16
Set di = DX.DirectInputCreate()
    Set diDEV = di.CreateDevice("GUID_SysKeyboard")
    diDEV.SetCommonDataFormat DIFORMAT_KEYBOARD
    diDEV.SetCooperativeLevel Me.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
    diDEV.Acquire
If InitSurfaceOffScreen(surfBackround, "", 640, 520) = False Then
    MsgBox "Cannot load backround"
    Terminate
End If
If InitSurfaceOffScreen(surfMap, App.Path + "\map.gif") = False Then
    MsgBox "Cannot load backround"
    Terminate
End If
If InitSurfaceOffScreen(surfCar, App.Path + "\car.gif") = False Then
    MsgBox "Cannot load car"
    Terminate
End If
If InitSurfaceOffScreen(surfRotate, "", 2 * (CInt(25 / Cos(PI / 4)) + 1), 2 * (CInt(25 / Cos(PI / 4)) + 1)) = False Then
    MsgBox "Cannot load temporary surface"
    Terminate
End If
If openmap(App.Path & "\map.txt") = False Then
    MsgBox "Cannot load map file"
    Terminate
End If
If bltbackround(surfMap, surfBackround) = False Then
    MsgBox "Cannot draw map"
    Terminate
End If

Dim key As DDCOLORKEY
key.high = 0 'vbMagenta
key.low = 0 'vbMagenta
surfCar.SetColorKey DDCKEY_SRCBLT, key

surfBackBuffer.SetForeColor vbWhite
'RotateSurface surfVaisseau, surfRotate, 45
Do While DoEvents
    check_keys
    Dostuff
Loop

End Sub


Public Function Dostuff()
    Static i As Integer
    Static tLast As Long
    Static sFps As String
    
    If i = 30 Then
        If tLast <> 0 Then sFps = CStr(Round(CSng(30000 / (timeGetTime - tLast)), 1))
        tLast = timeGetTime
        i = 0
    End If
    i = i + 1

Dim rSource As RECT, rDest As RECT
'blt the backround
rSource.Right = 640
rSource.Bottom = 480
surfBackBuffer.BltFast 0, 0, surfBackround, rSource, DDBLTFAST_WAIT

rSource.Right = 50
rSource.Bottom = 50
If lngAlpha >= 360 Then lngAlpha = 0
If lngAlpha < 0 Then lngAlpha = 360 + lngAlpha
Dim tempcarx As Long, tempcary As Long
calclocal
If carx < 0 Then carx = 0: speed = 0
If cary < 0 Then cary = 0: speed = 0
If carx + carwidth > 540 Then carx = 540 - carwidth: speed = 0
If cary + carheight > 500 Then cary = 500 - carheight: speed = 0
tempcarx = carx
tempcary = cary
RotateSurface surfCar, surfBackBuffer, lngAlpha, tempcarx, tempcary
If debugmode = True Then
surfBackBuffer.DrawText 10, 10, "Frame rate :" + sFps, False
surfBackBuffer.DrawText 10, 20, "Angle :" & CInt(lngAlpha), False
surfBackBuffer.DrawText 10, 30, "Carx :" & CInt(carx), False
surfBackBuffer.DrawText 10, 40, "Cary :" & CInt(cary), False
surfBackBuffer.DrawText 440, 10, "Keys :", False
surfBackBuffer.DrawText 440, 20, "Left: Rotate Car AntiClockwise", False
surfBackBuffer.DrawText 440, 30, "Right: Rotate Car Clockwise", False
surfBackBuffer.DrawText 440, 40, "Up: Forwards", False
surfBackBuffer.DrawText 440, 50, "Down: Reverse", False
surfBackBuffer.DrawText 440, 60, "Space: Brakes", False
surfBackBuffer.DrawText 440, 70, "Esc: End Game", False
Else
surfBackBuffer.DrawText 10, 10, "F1 for help", False
End If
surfBackBuffer.DrawText 100, 445, "GTA copy version 0.01 by JimCamel", False
surfBackBuffer.DrawText 100, 460, "jimcamel@jimcamel.8m.com", False
surfPrimary.Flip Nothing, DDFLIP_WAIT

End Function

